"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const fs_1 = require("fs");
const rimraf = require("rimraf");
const python_shell_1 = require("python-shell");
const script = path_1.join(__dirname, "./split.py");
exports.init = async (opts) => {
    const outputDirStr = opts.outputDir[opts.outputDir.length - 1];
    const options = {
        mode: "text",
        args: [
            opts.inputFile,
            outputDirStr,
            opts.numPages,
            opts.dataFile,
            opts.outputNamePrefix,
            opts.outputNameSuffix
        ] //
    };
    return new Promise(async (resolve, reject) => {
        try {
            await Promise.all(opts.outputDir.map(async (pth) => rimraf.sync(pth)));
            await Promise.all(opts.outputDir.map(async (pth) => fs_1.mkdirSync(pth)));
            let pyshell = new python_shell_1.PythonShell(script, options);
            // sends a message to the Python script via stdin
            pyshell.on("message", function (message) {
                // received a message sent from the Python script (a simple "print" statement)
                resolve(message);
            });
            // end the input stream and allow the process to exit
            pyshell.end(function (err) {
                if (err)
                    reject(err);
            });
        }
        catch (error) {
            reject(error);
        }
    });
};
